﻿var feature=null;
var route=null;
var osm_map=null;
var MarkerLayer=null;
var PathLayer=null;
var PolygonLayer=null;

function chooseAddr(lat1, lng1, lat2, lng2, osm_type) {
var loc1 = new L.LatLng(lat1, lng1);
var loc2 = new L.LatLng(lat2, lng2);
var bounds = new L.LatLngBounds(loc1, loc2);

	addr_search_remove();
	if (osm_type == "node") {
		feature = L.circle( loc1, 25, {color: 'green', fill: false}).addTo(osm_map);
		//osm_map.fitBounds(bounds);
		} else {
	var loc3 = new L.LatLng(lat1, lng2);
	var loc4 = new L.LatLng(lat2, lng1);

	feature = L.polyline( [loc1, loc4, loc2, loc3, loc1], {color: 'red'});
	//alert("Адрес1: "+lat1);
	osm_map.addLayer(feature);
	//osm_map.fitBounds(bounds);
	}
	osm_map.panTo([lat1,lng1]);	
	osm_map.setZoom(15);
}

//удаляем слой с адресом и маршрутом
function addr_search_remove() {
	if (feature) 		osm_map.removeLayer(feature);
	if(route) osm_map.removeLayer(route);
}

function addr_search_list(Address) {
    $.getJSON('http://nominatim.openstreetmap.org/search?format=json&limit=5&q=' + Address, function(data) {
        var items = [];

        $.each(data, function(key, val) {
            bb = val.boundingbox;
			//alert("Адрес: "+bb[0]);
            items.push("<li><a href='#' onclick='chooseAddr(" + bb[0] + ", " + bb[2] + ", " + bb[1] + ", " + bb[3] + ", \"" + val.osm_type + "\");return false;'>" + val.display_name + '</a></li>');
        });

	$('#results').empty();
        if (items.length != 0) {
            $('<p>', { html: "Результат поиска:" }).appendTo('#results');
            $('<ul/>', {
                'class': 'my-new-list',
                html: items.join('')
            }).appendTo('#results');
        } else {
            $('<p>', { html: "Ничего не найдено" }).appendTo('#results');
        }
    });
}

//сразу отображение на карте
function addr_search(Address) {
    $.getJSON('http://nominatim.openstreetmap.org/search?format=json&limit=1&q=' + Address, function(data) {
    var items = [];
        $.each(data, function(key, val) {
            bb = val.boundingbox;
			//alert("Адрес: "+bb[0]);
            chooseAddr(bb[0], bb[2], bb[1], bb[3], val.osm_type);
        });
    });
}

//получаем массив с широтой и долготой
function addr_search_array(Address) {
	var aaa=new Array();
$.ajaxSetup({        async: false , crossDomain:false, headers: {}   });
	
    $.getJSON('http://nominatim.openstreetmap.org/search?format=json&limit=1&q=' + Address, function(data) {
    var items = [];
        $.each(data, function(key, val) {
            bb = val.boundingbox;
			//alert("Адрес: "+bb[0]);
			aaa.push(bb[0]);
			aaa.push(bb[2]);
        });
    });
	$.ajaxSetup({        async: true    });
	return aaa;
}

//decode compressed route geometry
function OSRM_decode(encoded, precision) {
precision = Math.pow(10, -precision);
var len = encoded.length, index=0, lat=0, lng = 0, array = [];
while (index < len) {
var b, shift = 0, result = 0;
do {
b = encoded.charCodeAt(index++) - 63;
result |= (b & 0x1f) << shift;
shift += 5;
} while (b >= 0x20);
var dlat = ((result & 1) ? ~(result >> 1) : (result >> 1));
lat += dlat;
shift = 0;
result = 0;
do {
b = encoded.charCodeAt(index++) - 63;
result |= (b & 0x1f) << shift;
shift += 5;
} while (b >= 0x20);
var dlng = ((result & 1) ? ~(result >> 1) : (result >> 1));
lng += dlng;
//array.push( {lat: lat * precision, lng: lng * precision} );
array.push( [lat * precision, lng * precision] );
}
return array;
}
